## libcoap3 4.3.0

=== CMakeLists.txt ===
# CMakeLists.txt for libcoap
#
# Copyright (C) 2020 Carlos Gomes Martinho <carlos.gomes_martinho@siemens.com>
# Copyright (C) 2020-2021 Jon Shallow <supjps-libcoap@jpshallow.com>
#
# SPDX-License-Identifier: BSD-2-Clause
#
# This file is part of the CoAP library libcoap. Please see README for terms
# of use.

cmake_minimum_required(VERSION 3.10)

project(
  libcoap
  VERSION 4.3.0
  LANGUAGES CXX C)

set(LIBCOAP_API_VERSION 3)
set(COAP_LIBRARY_NAME "coap-${LIBCOAP_API_VERSION}")

option(
  BUILD_SHARED_LIBS
  "Build shared libs"
  OFF)

add_library(${COAP_LIBRARY_NAME})

#
# options to tweak the library
#

option(
  ENABLE_DTLS
  "Enable building with DTLS support"
  ON)
set(DTLS_BACKEND
    "default"
    CACHE
      STRING
      "\
Name of the dtls backend, only relevant if `ENABLE_DTLS` is ON which is default. \
Possible values: default, gnutls, openssl, tinydtls and mbedtls. \
If specified then this library will be searched and if found also used. \
If not found then the cmake configuration will stop with an error. \
If not specified, then cmake will try to use the first one found in the following order: \
gnutls, openssl, tinydtls, mbedtls \
    ")
set_property(
  CACHE DTLS_BACKEND
  PROPERTY STRINGS
           default
           openssl
           gnutls
           tinydtls
           mbedtls)
option(
  USE_VENDORED_TINYDTLS
  "compile with the tinydtls project in the submodule if on, otherwise try to find the compiled lib with find_package"
  ON)
option(
  WITH_EPOLL
  "compile with epoll support"
  ON)
option(
  ENABLE_SMALL_STACK
  "Define if the system has small stack size"
  OFF)
option(
  ENABLE_TCP
  "Enable building with TCP support"
  ON)
option(
  ENABLE_TESTS
  "build also tests"
  OFF)
option(
  ENABLE_EXAMPLES
  "build also examples"
  ON)
option(
  ENABLE_DOCS
  "build also doxygen documentation"
  ON)

if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug)
endif()

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_BINARY_DIR})
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_BINARY_DIR})
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(CheckCSourceCompiles)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckSymbolExists)
include(CheckTypeSize)
include(TestBigEndian)

# check for headers
check_include_file(byteswap.h HAVE_BYTESWAP_H)
check_include_file(inttypes.h HAVE_INTTYPES_H)
check_include_file(limits.h HAVE_LIMITS_H)
check_include_file(memory.h HAVE_MEMORY_H)
check_include_file(strings.h HAVE_STRINGS_H)
check_include_file(string.h HAVE_STRING_H)
check_include_file(sys/sysctl.h HAVE_SYS_SYSCTL_H)
check_include_file(net/if.h HAVE_NET_IF_H)
check_include_file(netinet/in.h HAVE_NETINET_IN_H)
check_include_file(sys/epoll.h HAVE_EPOLL_H)
check_include_file(sys/timerfd.h HAVE_TIMERFD_H)
check_include_file(arpa/inet.h HAVE_ARPA_INET_H)
check_include_file(stdbool.h HAVE_STDBOOL_H)
check_include_file(netdb.h HAVE_NETDB_H)
check_include_file(pthread.h HAVE_PTHREAD_H)
check_include_file(stdlib.h HAVE_STDINT_H)
check_include_file(stdint.h HAVE_STDLIB_H)
check_include_file(inttypes.h HAVE_INTTYPES_H)
check_include_file(syslog.h HAVE_SYSLOG_H)
check_include_file(sys/ioctl.h HAVE_SYS_IOCTL_H)
check_include_file(sys/socket.h HAVE_SYS_SOCKET_H)
check_include_file(sys/stat.h HAVE_SYS_STAT_H)
check_include_file(sys/time.h HAVE_SYS_TIME_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(sys/unistd.h HAVE_SYS_UNISTD_H)
check_include_file(time.h HAVE_TIME_H)
check_include_file(unistd.h HAVE_UNISTD_H)
check_include_file(float.h HAVE_FLOAT_H)
check_include_file(stddef.h HAVE_STDDEF_H)
check_include_file(winsock2.h HAVE_WINSOCK2_H)
check_include_file(ws2tcpip.h HAVE_WS2TCPIP_H)

# check for functions
check_function_exists(malloc HAVE_MALLOC)
check_function_exists(memset HAVE_MEMSET)
check_function_exists(select HAVE_SELECT)
check_function_exists(socket HAVE_SOCKET)
check_function_exists(strcasecmp HAVE_STRCASECMP)
check_function_exists(pthread_mutex_lock HAVE_PTHREAD_MUTEX_LOCK)
check_function_exists(getaddrinfo HAVE_GETADDRINFO)
check_function_exists(strnlen HAVE_STRNLEN)
check_function_exists(strrchr HAVE_STRRCHR)
check_function_exists(getrandom HAVE_GETRANDOM)

# check for symbols
if(WIN32)
  set(HAVE_STRUCT_CMSGHDR 1)
else()
  check_symbol_exists(
    cmsghdr
    sys/socket.h
    HAVE_STRUCT_CMSGHDR)
endif()

if(${WITH_EPOLL}
   AND ${HAVE_EPOLL_H}
   AND ${HAVE_TIMERFD_H})
  set(COAP_EPOLL_SUPPORT "1")
  message(STATUS "compiling with epoll support")
else()
  message(STATUS "compiling without epoll support")
endif()

if(ENABLE_SMALL_STACK)
  set(ENABLE_SMALL_STACK "${ENABLE_SMALL_STACK}")
  message(STATUS "compiling with small stack support")
endif()

set(WITH_GNUTLS OFF)
set(WITH_OPENSSL OFF)
set(WITH_TINYDTLS OFF)
set(WITH_MBEDTLS OFF)

function(compile_tinydtls)
  set(TINYDTLS_SOURCES_DIR ${CMAKE_CURRENT_LIST_DIR}/ext/tinydtls)
  set(TINYDTLS_SOURCES_GENERATED ${TINYDTLS_SOURCES_DIR}/dtls_config.h)

  message(STATUS "compiling the tinydtls lib")

  include(ExternalProject)

  externalproject_add(
    external_tinydtls
    SOURCE_DIR "${TINYDTLS_SOURCES_DIR}"
    BUILD_IN_SOURCE 1
    DOWNLOAD_COMMAND ""
    UPDATE_COMMAND ""
    CONFIGURE_COMMAND
      ${TINYDTLS_SOURCES_DIR}/configure
      --disable-manpages
      --prefix=${CMAKE_BINARY_DIR}
    BUILD_COMMAND make install
    INSTALL_COMMAND ""
    LOG_DOWNLOAD 1
    LOG_CONFIGURE 1)

  externalproject_add_step(
    external_tinydtls autoreconf
    COMMAND autoreconf --force --install
    ALWAYS 1
    WORKING_DIRECTORY "${TINYDTLS_SOURCES_DIR}"
    DEPENDERS configure
    DEPENDEES download)

  # Let cmake know that it needs to execute the external_tinydtls target to generate those files.
  add_custom_command(
    OUTPUT ${TINYDTLS_SOURCES_GENERATED}
    WORKING_DIRECTORY "${TINYDTLS_SOURCES_DIR}"
    COMMAND "make install"
    DEPENDS external_tinydtls)

  add_dependencies(${COAP_LIBRARY_NAME} external_tinydtls)

  if(BUILD_SHARED_LIBS)
    set(LIBTINYDTLS_PATH "${CMAKE_CURRENT_BINARY_DIR}/lib/libtinydtls.so")
  else()
    set(LIBTINYDTLS_PATH "${CMAKE_CURRENT_BINARY_DIR}/lib/libtinydtls.a")
  endif()

  add_library(
    tinydtls
    UNKNOWN
    IMPORTED)
  set_target_properties(
    tinydtls
    PROPERTIES INTERFACE_INCLUDE_DIRECTORIES
               "${CMAKE_CURRENT_BINARY_DIR}/include"
               IMPORTED_LINK_INTERFACE_LANGUAGES "C"
               IMPORTED_LOCATION "${LIBTINYDTLS_PATH}")

endfunction()

if(ENABLE_DTLS)
  message(STATUS "compiling with DTLS support")
  message(STATUS "DTLS_BACKEND: ${DTLS_BACKEND}")

  if(DTLS_BACKEND
     STREQUAL
     "default")
    # try to find a crypto lib and use it, use the first one found

    # libgnutls (e.g. debian libgnutls28-dev)
    find_package(GnuTLS)
    if(GnuTLS_FOUND)
      set(WITH_GNUTLS ON)
      message(STATUS "compiling with gnutls support")
      set(HAVE_LIBGNUTLS 1)
    else()
      # gnutls not found
      find_package(OpenSSL)
      if(OpenSSL_FOUND)
        set(WITH_OPENSSL ON)
        message(STATUS "compiling with openssl support")
        set(HAVE_OPENSSL 1)
      else()
        # openssl not found
        # libmbedtls (e.g. debian libmbedtls-dev)
        find_package(MbedTLS)
        if(MbedTLS_FOUND)
          set(WITH_MBEDTLS ON)
          message(STATUS "compiling with mbedtls support")
          set(HAVE_MBEDTLS 1)
        else()
          # mbedtls not found
          if(USE_VENDORED_TINYDTLS)
            compile_tinydtls()
          else()
            find_package(TinyDTLS)
            if(TINYDTLS_FOUND)

            else()
              # no cryto lib found
              message(
                FATAL_ERROR
                  "cannot find any cryto lib, either install one or compile without DTLS support"
              )
            endif()

          endif()

          set(WITH_TINYDTLS ON)
          message(STATUS "compiling with tinydtls support")
          set(HAVE_LIBTINYDTLS 1)

        endif()

      endif()

    endif()

  else()
    # DTLS_BACKEND variable is not empty, so set all to false and set the only right to true
    set(WITH_GNUTLS OFF)
    set(WITH_TINYDTLS OFF)
    set(WITH_MBEDTLS OFF)
    set(WITH_OPENSSL OFF)

    if(DTLS_BACKEND
       STREQUAL
       "gnutls")
      # libgnutls (e.g. debian libgnutls28-dev)
      find_package(GnuTLS REQUIRED)
      set(WITH_GNUTLS ON)
      message(STATUS "compiling with gnutls support")
      set(HAVE_LIBGNUTLS 1)
    endif()

    if(DTLS_BACKEND
       STREQUAL
       "openssl")
      # libssl (e.g. debian libssl1.0-dev)
      find_package(OpenSSL REQUIRED)
      set(WITH_OPENSSL ON)
      message(STATUS "compiling with openssl support")
      set(HAVE_OPENSSL 1)
    endif()

    if(DTLS_BACKEND
       STREQUAL
       "mbedtls")
      # libmbedtls (e.g. debian libmbedtls-dev)
      find_package(MbedTLS REQUIRED)
      set(WITH_MBEDTLS ON)
      message(STATUS "compiling with mbedtls support")
      set(HAVE_MBEDTLS 1)
    endif()

    if(DTLS_BACKEND
       STREQUAL
       "tinydtls")

      if(USE_VENDORED_TINYDTLS)
        compile_tinydtls()
      else(USE_VENDORED_TINYDTLS)
        find_package(TinyDTLS REQUIRED)
      endif(USE_VENDORED_TINYDTLS)

      message(STATUS "compiling with tinydtls support")
      set(WITH_TINYDTLS ON)
      set(HAVE_LIBTINYDTLS 1)

    endif()

  endif()

endif()

message(STATUS "ENABLE_DTLS:.....................${ENABLE_DTLS}")
message(STATUS "ENABLE_TCP:......................${ENABLE_TCP}")
message(STATUS "ENABLE_DOCS:.....................${ENABLE_DOCS}")
message(STATUS "ENABLE_EXAMPLES:.................${ENABLE_EXAMPLES}")
message(STATUS "DTLS_BACKEND:....................${DTLS_BACKEND}")
message(STATUS "WITH_GNUTLS:.....................${WITH_GNUTLS}")
message(STATUS "WITH_TINYDTLS:...................${WITH_TINYDTLS}")
message(STATUS "WITH_OPENSSL:....................${WITH_OPENSSL}")
message(STATUS "WITH_MBEDTLS:....................${WITH_MBEDTLS}")
message(STATUS "HAVE_LIBTINYDTLS:................${HAVE_LIBTINYDTLS}")
message(STATUS "HAVE_LIBGNUTLS:..................${HAVE_LIBGNUTLS}")
message(STATUS "HAVE_OPENSSL:....................${HAVE_OPENSSL}")
message(STATUS "HAVE_MBEDTLS:....................${HAVE_MBEDTLS}")
message(STATUS "COAP_EPOLL_SUPPORT:..............${COAP_EPOLL_SUPPORT}")
message(STATUS "CMAKE_C_COMPILER:................${CMAKE_C_COMPILER}")
message(STATUS "BUILD_SHARED_LIBS:...............${BUILD_SHARED_LIBS}")
message(STATUS "CMAKE_BUILD_TYPE:................${CMAKE_BUILD_TYPE}")
message(STATUS "CMAKE_SYSTEM_PROCESSOR:..........${CMAKE_SYSTEM_PROCESSOR}")

set(PACKAGE_URL "https://libcoap.net/")
set(PACKAGE_NAME "${PROJECT_NAME}")
set(PACKAGE_TARNAME "${PROJECT_NAME}")
set(PACKAGE_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
set(PACKAGE_VERSION "${PROJECT_VERSION}")
set(LIBCOAP_PACKAGE_VERSION "${PROJECT_VERSION}")
set(LIBCOAP_PACKAGE_URL "${PACKAGE_URL}")
set(LIBCOAP_PACKAGE_NAME "${PROJECT_NAME}")
set(LIBCOAP_PACKAGE_STRING "TODO")
set(LIBCOAP_PACKAGE_BUGREPORT "libcoap-developers@lists.sourceforge.net")
set(PACKAGE_BUGREPORT "libcoap-developers@lists.sourceforge.net")
set(top_srcdir "${CMAKE_CURRENT_LIST_DIR}")
set(top_builddir "${CMAKE_CURRENT_BINARY_DIR}")
if(ENABLE_TCP)
  set(COAP_DISABLE_TCP 0)
else(ENABLE_TCP)
  set(COAP_DISABLE_TCP 1)
endif(ENABLE_TCP)

# creates config header file in build directory
configure_file(${CMAKE_CURRENT_LIST_DIR}/include/coap${LIBCOAP_API_VERSION}/coap.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/include/coap${LIBCOAP_API_VERSION}/coap.h)

configure_file(${CMAKE_CURRENT_LIST_DIR}/cmake_coap_config.h.in
               ${CMAKE_CURRENT_BINARY_DIR}/coap_config.h)

configure_file(${CMAKE_CURRENT_LIST_DIR}/tests/test_common.h.in
               ${CMAKE_CURRENT_LIST_DIR}/tests/test_common.h)

#
# sources
#

target_sources(
  ${COAP_LIBRARY_NAME}
  PRIVATE ${CMAKE_CURRENT_LIST_DIR}/src/address.c

=== debian/changelog ===
libcoap3 (4.3.0-2build1) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Mon, 29 Nov 2021 10:07:28 +0100

libcoap3 (4.3.0-2) unstable; urgency=medium

  * [e1af96c] Rebuild patch queue from patchqueue branch
    Added patch: pkg-config-Don-t-use-hard-coded-binary.patch
    (Closes: #996652)

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 17 Oct 2021 09:18:09 +0200

libcoap3 (4.3.0-1) unstable; urgency=medium

  * [54d24e4] d/gbp.conf: Adjust to unstable
  * [d523e17] d/control: Update Standards-Version to 4.6.0
    No further changes needed.
  * [8dc446d] d/libcoap3.lintian-overrides: Small typo fixes
  * [21e33a3] d/libcoap3-bin.lintian-overrides: Catch up issue more generic

 -- Carsten Schoenert <c.schoenert@t-online.de>  Fri, 17 Sep 2021 20:45:39 +0200

libcoap3 (4.3.0-1~exp1) experimental; urgency=medium

  * [2648182] New upstream version 4.3.0
  * [0cc065f] Remove patch queue
    No need any more for a patch queue right now.
  * [6c00820] d/libcoap3.docs: Also install the file README
  * [e71020f] d/rules: Add new default configure options
  * [d316b54] d/rules: Don't remove all files named *Makefile
  * [a391b91] d/libcoap3-dev.doc: New sequencer to get examples installed
  * [3c70fd8] d/control: Adding Rules-Requires-Root entry
  * [3a0f766] d/libcoap3-bin.lintian-overrides: Ignore one advice

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sun, 27 Jun 2021 09:21:15 +0200

libcoap3 (4.3.0~rc2-1) experimental; urgency=medium

  * initial packaging (Closes: #987417)
  * [afafa79] New upstream version 4.3.0~rc2

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sat, 24 Apr 2021 08:50:07 +0200

=== debian/control ===
Source: libcoap3
Section: libs
Priority: optional
Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders:
 Carsten Schoenert <c.schoenert@t-online.de>,
Build-Depends:
 asciidoc,
 debhelper-compat (= 13),
 doxygen,
 exuberant-ctags,
 graphviz,
 libgnutls28-dev,
 libssl-dev,
 pkg-config,
 xmlto,
Standards-Version: 4.6.0
Rules-Requires-Root: binary-targets
Homepage: https://libcoap.net/
Vcs-Browser: https://salsa.debian.org/debian-iot-team/libcoap3
Vcs-Git: https://salsa.debian.org/debian-iot-team/libcoap3.git

Package: libcoap3
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 libcoap2,
Description: C-Implementation of CoAP - libraries API version 3
 Lightweight application-protocol for devices that are constrained their
 resources such as computing power, RF range, memory, bandwidth, or network
 packet sizes. This protocol, CoAP, is developed in the IETF working group
 "CoRE", <http://6lowapp.net> and was standardized in RFC 7252.
 .
 The libcoap library v3 has DTLS functionality included based on TLS
 functions provided by GnuTLS or OpenSSL with enhanced behavior to the
 previous API version.
 .
 This package contains the various libcoap libraries based on API v3 with
 and without DTLS functionality.

Package: libcoap3-bin
Architecture: any
Depends:
 libcoap3 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 libcoap2-bin,
Description: C-Implementation of CoAP - example binaries API version 3
 The libcoap provides some example binary files to show the usage of a CoAP
 Server, CoAP Client and a Resource Directory implementation. These examples
 heavily rely on the libcoap as the core functionality is based there.
 .
 This package provides the following example binaries without DTLS functions:
  * coap-client-notls
    A command-line client that allows you to interact with CoAP resources.
 .
  * coap-server-notls
    Simple server that can provide CoAP resources for simple testing cases.
 .
  * coap-rd-notls
    This binary let you simulate various CoAP resources mostly for testing
    purpose.
 .
 This package provides the following example binaries with DTLS functions:
  * coap-client-{gnutls,openssl}
    A command-line client that allows you to interact with CoAP resources
    based on TLS functions by GnuTLS or OpenSSL.
 .
  * coap-server-{gnutls,openssl}
    Simple server that can provide CoAP resources for simple testing cases
    based on TLS functions by GnuTLS or OpenSSL.
 .
  * coap-rd-{gnutls,openssl}
    This binary let you simulate various CoAP resources mostly for testing
    based on TLS functions by GnuTLS or OpenSSL.
 .
 You can use these files without any exception no matter as they named
 examples. Please see the respective man pages for usage instructions.

Package: libcoap3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libc6-dev,
 libcoap3 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: C-Implementation of CoAP - development files API version 3
 Lightweight application-protocol for devices that are constrained their
 resources such as computing power, RF range, memory, bandwidth, or network
 packet sizes. This protocol, CoAP, is developed in the IETF working group
 "CoRE", <http://6lowapp.net> and was standardized in RFC 7252.
 .
 This package contains the developer files like headers, the static library
 and the pkg-config files.

Package: libcoap3-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 ${misc:Depends},
Recommends:
 libcoap3-dev (= ${binary:Version}),
 www-browser,
Description: C-Implementation of CoAP - HTML based documentation files for API v3
 Lightweight application-protocol for devices that are constrained their
 resources such as computing power, RF range, memory, bandwidth, or network
 packet sizes. This protocol, CoAP, is developed in the IETF working group
 "CoRE", <http://6lowapp.net> and was standardized in RFC 7252.
 .
 This package contains the Doxygen generated library API HTML documentation
 for libcoap.
 They can be accessed by open /usr/share/doc/libcoap3-doc/html/index.html.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_HOST_ARCH_OS   ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

include /usr/share/dpkg/pkg-info.mk
export REVDATE := $(shell TZ=UTC date -d@"$(SOURCE_DATE_EPOCH)" +%Y-%m-%d)

DEB_BUILD_DIR = debian/build
INSTDIR := $(CURDIR)/debian/tmp

DEB_CONFIGURE_OPTS = \
	--prefix=/usr \
	--mandir=\$${prefix}/share/man \
	--infodir=\$${prefix}/share/info \
	--htmldir=\$${prefix}/share/doc/libcoap \
	--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
	--build=$(DEB_BUILD_GNU_TYPE) \
	--host=$(DEB_HOST_GNU_TYPE) \
	--enable-shared \
	--enable-static \
	--disable-add-default-names \
	--disable-as-dtls-default \
	--disable-documentation \
	--disable-doxygen \
	--disable-license-install \
	--disable-manpages \
	--enable-examples \
	$(NULL)

DEB_CONFIGURE_DTLS_NO_OPTS = \
	$(DEB_CONFIGURE_OPTS) \
	--disable-dtls \
	--enable-documentation \
	--enable-doxygen \
	--enable-manpages \
	$(NULL)

DEB_CONFIGURE_DTLS_OPENSSL_OPTS = \
	$(DEB_CONFIGURE_OPTS) \
	--enable-dtls \
	--with-openssl \
	$(NULL)

DEB_CONFIGURE_DTLS_GNUTLS_OPTS = \
	$(DEB_CONFIGURE_OPTS) \
	--enable-dtls \
	--with-gnutls \
	$(NULL)

PREPROCESS_FILES := $(wildcard debian/*.in)

$(PREPROCESS_FILES:.in=): %: %.in
	sed 's,/@DEB_HOST_MULTIARCH@,$(DEB_HOST_MULTIARCH:%=/%),g' $< > $@

%:
	dh $@

override_dh_auto_clean:
	dh_clean
	if [ -f Makefile ]; then \
		make clean ;\
	fi
	for i in `find $(CURDIR) -type f \
		\( -name "Makefile" \
		-o -name "libcoap-3*.pc" \
		-o -name "$(PACKAGE_BASE).dirs" -o -name "$(PACKAGE_BASE)-dev.dirs" \
		-o -name "$(PACKAGE_BASE).install" -o -name "$(PACKAGE_BASE)-dev.install" \
		-o -name "coap_config.h" \
		-o -name ".dirstamp" \
		-o -name "tags" \
		-o -name "Doxyfile" \)` ;\
	do rm -f $$i; done
	rm -f config.log config.status  libtool stamp-h1
	for i in `find $(CURDIR) -type d \
		\( -name ".deps" \)` ;\
	do rm -rf $$i; done

override_dh_auto_configure:
	sed -i 's/@REVDATE@/$(REVDATE)/' man/coap-*.txt.in
	mkdir -p $(DEB_BUILD_DIR)
	#
	########################################
	# configure build with no DTLS support #
	########################################
	dh_auto_configure --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/nodtls -- $(DEB_CONFIGURE_DTLS_NO_OPTS)
	#
	#############################################
	# configure build with OpenSSL DTLS support #
	#############################################
	dh_auto_configure --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/openssl -- $(DEB_CONFIGURE_DTLS_OPENSSL_OPTS)
	#
	############################################
	# configure build with GnuTLS DTLS support #
	############################################
	dh_auto_configure --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/gnutls -- $(DEB_CONFIGURE_DTLS_GNUTLS_OPTS)

override_dh_auto_build:
	#
	#######################################
	# build libcoap3 with no DTLS support #
	#######################################
	dh_auto_build --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/nodtls
	#
	############################################
	# build libcoap3 with OpenSSL DTLS support #
	############################################
	dh_auto_build --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/openssl
	#
	###########################################
	# build libcoap3 with GnuTLS DTLS support #
	###########################################
	dh_auto_build --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/gnutls

override_dh_auto_install: $(PREPROCESS_FILES:.in=)
	#
	####################################################
	# installing libcoap3 library with no DTLS support #
	####################################################
	dh_auto_install --destdir=$(INSTDIR) --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/nodtls
	#
	#######################################################
	# installing libcoap3 library with no OpenSSL support #
	#######################################################
	dh_auto_install --destdir=$(INSTDIR) --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/openssl
	#
	####################################################
	# installing libcoap3 library with no DTLS support #
	####################################################
	dh_auto_install --destdir=$(INSTDIR) --sourcedirectory=$(CURDIR) --builddirectory=$(DEB_BUILD_DIR)/gnutls
	# Find useless .la file and remove them.
	find $(INSTDIR) -name '*.la' | xargs rm


#override_dh_auto_test:

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 4 file
version=4

opts="mode=git, \
      uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\.?\d*)$/$1~$2/, \
      dversionmangle=s/\+ds(\.?\d+)?$//" \
      https://github.com/obgm/libcoap.git \
         refs/tags/v(\d+\.\d+\.\d+(?:\.?beta[1-9])?)

## libcoap3 4.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # CMakeLists.txt for libcoap
 #
 # Copyright (C) 2020 Carlos Gomes Martinho <carlos.gomes_martinho@siemens.com>
-# Copyright (C) 2020-2021 Jon Shallow <supjps-libcoap@jpshallow.com>
+# Copyright (C) 2020-2022 Jon Shallow <supjps-libcoap@jpshallow.com>
 #
 # SPDX-License-Identifier: BSD-2-Clause
 #
@@ -12,7 +12,7 @@
 
 project(
   libcoap
-  VERSION 4.3.0
+  VERSION 4.3.1
   LANGUAGES CXX C)
 
 set(LIBCOAP_API_VERSION 3)
@@ -58,6 +58,14 @@
   "compile with the tinydtls project in the submodule if on, otherwise try to find the compiled lib with find_package"
   ON)
 option(
+  ENABLE_CLIENT_MODE
+  "compile with support for client mode code"
+  ON)
+option(
+  ENABLE_SERVER_MODE
+  "compile with support for server mode code"
+  ON)
+option(
   WITH_EPOLL
   "compile with epoll support"
   ON)
@@ -92,6 +100,10 @@
 
 if(MSVC)
   add_definitions(-D_CRT_SECURE_NO_WARNINGS)
+endif()
+
+if(APPLE)
+  add_definitions(-D__APPLE_USE_RFC_3542=1)
 endif()
 
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_BINARY_DIR})
@@ -123,7 +135,6 @@
 check_include_file(pthread.h HAVE_PTHREAD_H)
 check_include_file(stdlib.h HAVE_STDINT_H)
 check_include_file(stdint.h HAVE_STDLIB_H)
-check_include_file(inttypes.h HAVE_INTTYPES_H)
 check_include_file(syslog.h HAVE_SYSLOG_H)
 check_include_file(sys/ioctl.h HAVE_SYS_IOCTL_H)
 check_include_file(sys/socket.h HAVE_SYS_SOCKET_H)
@@ -149,15 +160,30 @@
 check_function_exists(strnlen HAVE_STRNLEN)
 check_function_exists(strrchr HAVE_STRRCHR)
 check_function_exists(getrandom HAVE_GETRANDOM)
+check_function_exists(if_nametoindex HAVE_IF_NAMETOINDEX)
 
 # check for symbols
 if(WIN32)
   set(HAVE_STRUCT_CMSGHDR 1)
 else()
   check_symbol_exists(
-    cmsghdr
+    CMSG_FIRSTHDR
     sys/socket.h
     HAVE_STRUCT_CMSGHDR)
+endif()
+
+if(${ENABLE_CLIENT_MODE})
+  set(COAP_CLIENT_SUPPORT "1")
+  message(STATUS "compiling with client support")
+else()
+  message(STATUS "compiling without client support")
+endif()
+
+if(${ENABLE_SERVER_MODE})
+  set(COAP_SERVER_SUPPORT "1")
+  message(STATUS "compiling with server support")
+else()
+  message(STATUS "compiling without server support")
 endif()
 
 if(${WITH_EPOLL}
@@ -353,8 +379,35 @@
 
 endif()
 
+execute_process(COMMAND git describe --tags --dirty --always
+                RESULT_VARIABLE USING_GIT
+                OUTPUT_VARIABLE LIBCOAP_PACKAGE_BUILD
+                OUTPUT_STRIP_TRAILING_WHITESPACE
+                ERROR_QUIET)
+if(NOT ${USING_GIT} EQUAL 0)
+  set(LIBCOAP_PACKAGE_BUILD ${PROJECT_VERSION})
+else()
+  set(LIBCOAP_PACKAGE_BUILD "${LIBCOAP_PACKAGE_BUILD}")
+endif()
+
+set(PACKAGE_URL "https://libcoap.net/")
+set(PACKAGE_NAME "${PROJECT_NAME}")
+set(PACKAGE_TARNAME "${PROJECT_NAME}")
+set(PACKAGE_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
+set(PACKAGE_VERSION "${PROJECT_VERSION}")
+set(PACKAGE_BUGREPORT "libcoap-developers@lists.sourceforge.net")
+set(LIBCOAP_PACKAGE_VERSION "${PACKAGE_VERSION}")
+set(LIBCOAP_PACKAGE_URL "${PACKAGE_URL}")
+set(LIBCOAP_PACKAGE_NAME "${PACKAGE_NAME}")
+set(LIBCOAP_PACKAGE_STRING "${PACKAGE_STRING}")
+set(LIBCOAP_PACKAGE_BUGREPORT "${PACKAGE_BUGREPORT}")
+
+message(STATUS "PACKAGE VERSION..................${PACKAGE_VERSION}")
+message(STATUS "PACKAGE BUILD....................${LIBCOAP_PACKAGE_BUILD}")
 message(STATUS "ENABLE_DTLS:.....................${ENABLE_DTLS}")
 message(STATUS "ENABLE_TCP:......................${ENABLE_TCP}")
+message(STATUS "ENABLE_CLIENT_MODE:..............${ENABLE_CLIENT_MODE}")
+message(STATUS "ENABLE_SERVER_MODE:..............${ENABLE_SERVER_MODE}")
 message(STATUS "ENABLE_DOCS:.....................${ENABLE_DOCS}")
 message(STATUS "ENABLE_EXAMPLES:.................${ENABLE_EXAMPLES}")
 message(STATUS "DTLS_BACKEND:....................${DTLS_BACKEND}")
@@ -364,47 +417,3 @@
 message(STATUS "WITH_MBEDTLS:....................${WITH_MBEDTLS}")
 message(STATUS "HAVE_LIBTINYDTLS:................${HAVE_LIBTINYDTLS}")
 message(STATUS "HAVE_LIBGNUTLS:..................${HAVE_LIBGNUTLS}")
-message(STATUS "HAVE_OPENSSL:....................${HAVE_OPENSSL}")
-message(STATUS "HAVE_MBEDTLS:....................${HAVE_MBEDTLS}")
-message(STATUS "COAP_EPOLL_SUPPORT:..............${COAP_EPOLL_SUPPORT}")
-message(STATUS "CMAKE_C_COMPILER:................${CMAKE_C_COMPILER}")
-message(STATUS "BUILD_SHARED_LIBS:...............${BUILD_SHARED_LIBS}")
-message(STATUS "CMAKE_BUILD_TYPE:................${CMAKE_BUILD_TYPE}")
-message(STATUS "CMAKE_SYSTEM_PROCESSOR:..........${CMAKE_SYSTEM_PROCESSOR}")
-
-set(PACKAGE_URL "https://libcoap.net/")
-set(PACKAGE_NAME "${PROJECT_NAME}")
-set(PACKAGE_TARNAME "${PROJECT_NAME}")
-set(PACKAGE_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
-set(PACKAGE_VERSION "${PROJECT_VERSION}")
-set(LIBCOAP_PACKAGE_VERSION "${PROJECT_VERSION}")
-set(LIBCOAP_PACKAGE_URL "${PACKAGE_URL}")
-set(LIBCOAP_PACKAGE_NAME "${PROJECT_NAME}")
-set(LIBCOAP_PACKAGE_STRING "TODO")
-set(LIBCOAP_PACKAGE_BUGREPORT "libcoap-developers@lists.sourceforge.net")
-set(PACKAGE_BUGREPORT "libcoap-developers@lists.sourceforge.net")
-set(top_srcdir "${CMAKE_CURRENT_LIST_DIR}")
-set(top_builddir "${CMAKE_CURRENT_BINARY_DIR}")
-if(ENABLE_TCP)
-  set(COAP_DISABLE_TCP 0)
-else(ENABLE_TCP)
-  set(COAP_DISABLE_TCP 1)
-endif(ENABLE_TCP)
-
-# creates config header file in build directory
-configure_file(${CMAKE_CURRENT_LIST_DIR}/include/coap${LIBCOAP_API_VERSION}/coap.h.in
-               ${CMAKE_CURRENT_BINARY_DIR}/include/coap${LIBCOAP_API_VERSION}/coap.h)
-
-configure_file(${CMAKE_CURRENT_LIST_DIR}/cmake_coap_config.h.in
-               ${CMAKE_CURRENT_BINARY_DIR}/coap_config.h)
-
-configure_file(${CMAKE_CURRENT_LIST_DIR}/tests/test_common.h.in
-               ${CMAKE_CURRENT_LIST_DIR}/tests/test_common.h)
-
-#
-# sources
-#
-
-target_sources(
-  ${COAP_LIBRARY_NAME}
-  PRIVATE ${CMAKE_CURRENT_LIST_DIR}/src/address.c

=== debian/changelog ===
libcoap3 (4.3.1-2) unstable; urgency=medium

  * [ff7e712] Rebuild patch queue from patch-queue branch
    Added patch:
    CVE-2023-30362-Fix-buffer-overflow-in-coap_send_internal.patch
    (Closes: #1040594)
  * [2d091bc] d/control: Update Standards-Version to 4.6.2
    No further changes needed.

 -- Carsten Schoenert <c.schoenert@t-online.de>  Sat, 08 Jul 2023 13:07:15 +0200

libcoap3 (4.3.1-1) unstable; urgency=medium

  [ Debian Janitor ]
  * [67731af] Set upstream metadata fields: Repository.

  [ Carsten Schoenert ]
  * [99a9767] New upstream version 4.3.1
  * [3daaf3d] Rebuild patch queue from patch-queue branch
    Added patches:
    Modeline-Correct-vim-modline-syntax.patch
    Spelling-Fix-minor-spelling-and-typos.patch
    Dropped patch (applied upstream):
    pkg-config-Don-t-use-hard-coded-binary.patch
  * [c91abcf] d/control: Update some build dependencies
  * [b87ad73] d/control: Update Standards-Version to 4.6.1
    No further changes needed.
  * [baf2a70] d/u/metadata: Add some more data

 -- Carsten Schoenert <c.schoenert@t-online.de>  Mon, 28 Nov 2022 11:51:55 +0100

=== debian/control ===
--- 
+++ 
@@ -5,16 +5,16 @@
 Uploaders:
  Carsten Schoenert <c.schoenert@t-online.de>,
 Build-Depends:
- asciidoc,
+ asciidoc-base,
  debhelper-compat (= 13),
  doxygen,
  exuberant-ctags,
  graphviz,
  libgnutls28-dev,
  libssl-dev,
- pkg-config,
+ pkgconf,
  xmlto,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: binary-targets
 Homepage: https://libcoap.net/
 Vcs-Browser: https://salsa.debian.org/debian-iot-team/libcoap3
